/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>

void
cbx_toggle_callback ( GtkToggleButton* btn, GdkEvent* evt, gpointer data ) {
  // printf( "active: %d\n", btn->active);
  if ( getWidgetIdx( btn, evt ) > -1 ) {
    (*X->env)->CallStaticObjectMethod( X->env, ItemEvent, queueItemEvent, X->srcIdx,
				       (X->evtId = btn->active ? ITEM_SELECTED : ITEM_DESELECTED) );
  }
}

void
connect_cbx_signals( GtkWidget* w) {
  gtk_signal_connect( GTK_OBJECT( w), "toggled", GTK_SIGNAL_FUNC( cbx_toggle_callback), NULL);
}

void*
Java_java_awt_Toolkit_cbxCreateCheckbox ( JNIEnv* env, jclass clazz, jstring label )
{
  char* buf = java2CString( env, X, label);
  Widget *widget = calloc( 1, sizeof( Widget));

  GtkCheckButton* btn = gtk_check_button_new_with_label( buf);;

  widget->widget = btn;
  connect_cbx_signals( btn);

  return (void*)widget;
}

void
Java_java_awt_Toolkit_cbxSetState( JNIEnv* env, jclass clazz, void* nd, jboolean state)
{
  GtkToggleButton* btn = GTK_TOGGLE_BUTTON( ((Widget*)nd)->widget);
  gtk_toggle_button_set_state( btn, state);
}

jboolean
Java_java_awt_Toolkit_cbxGetState( JNIEnv* env, jclass clazz, void* nd)
{
  GtkToggleButton* btn = GTK_TOGGLE_BUTTON( ((Widget*)nd)->widget);
  return (gboolean) btn->active;
}

void
Java_java_awt_Toolkit_cbxSetLabel( JNIEnv* env, jclass clazz, void* nd, jstring label)
{
  GtkButton* btn = GTK_BUTTON( ((Widget*)nd)->widget);
  GtkLabel* lbl = GTK_LABEL( btn->child );
  char* buf = java2CString( env, X, label);

  gtk_label_set( lbl, buf);
}
