/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>


void
select_child_callback ( GtkList* list, GtkWidget* child,  gpointer data ) {
  gint row = gtk_list_child_position( list, child);
  if ( getWidgetIdx( (GtkWidget*) data, NULL ) > -1 ) {
    (*X->env)->CallStaticObjectMethod( X->env, ItemEvent, queueItemEvent,
				       X->srcIdx, (X->evtId = ITEM_SELECTED), row );
  }
}

void
connect_cho_signals( GtkCombo* c) {
  gtk_signal_connect( GTK_OBJECT( c->list), "select_child", GTK_SIGNAL_FUNC( select_child_callback), (gpointer) c);
  gtk_signal_connect( GTK_OBJECT( c), "key_press_event", GTK_SIGNAL_FUNC( key_press_callback), NULL);
}


void*
Java_java_awt_Toolkit_choCreateChoice ( JNIEnv* env, jclass clazz  )
{
  Widget *widget = calloc( 1, sizeof( Widget));

  GtkCombo* cho = gtk_combo_new();

  widget->widget = cho;
  gtk_list_set_selection_mode( cho->list, GTK_SELECTION_BROWSE );

  connect_cho_signals( cho);

  return (void*)widget;
}

void
Java_java_awt_Toolkit_choAppendItem( JNIEnv* env, jclass clazz, void* nd, jstring item)
{
  char* buf = java2CString( env, X, item);
  GtkCombo* cho = GTK_COMBO( ((Widget*)nd)->widget);
  GtkWidget* li = gtk_list_item_new_with_label( buf);
  
  gtk_widget_show( li);
  gtk_container_add( GTK_CONTAINER( cho->list), li);
}

void
Java_java_awt_Toolkit_choRemoveAll( JNIEnv* env, jclass clazz, void* nd)
{
  GtkCombo* cho = GTK_COMBO( ((Widget*)nd)->widget);
  gtk_list_clear_items( GTK_LIST( cho->list), 0, -1);
}

void
Java_java_awt_Toolkit_choSelectItem( JNIEnv* env, jclass clazz, void* nd, jint idx)
{
  GtkCombo* cho = GTK_COMBO( ((Widget*)nd)->widget);
  gtk_list_select_item( GTK_LIST( cho->list), idx);
}
