/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>

void
Java_java_awt_Toolkit_editSetText ( JNIEnv* env, jclass clazz, void* nd, jstring text )
{
  char* buf = java2CString( env, X, text);
  Widget* w = (Widget*) nd;
  GtkEditable* ed = GTK_EDITABLE( w->widget);
  GdkColor cf, cb;

  if ( GTK_IS_ENTRY (ed) )
    gtk_entry_set_text( GTK_ENTRY( ed), buf);
  else {
    cf.pixel = w->fg;
    cb.pixel = w->bg;
    gtk_editable_delete_text( ed, 0, -1);
    gtk_text_insert( GTK_TEXT( ed), w->fnt, &cf, &cb, buf, strlen( buf));
  }
    
}

jstring
Java_java_awt_Toolkit_editGetText ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gchar* buf = gtk_editable_get_chars( ed, 0, -1);

  return (*env)->NewStringUTF( env, buf);
}

jstring
Java_java_awt_Toolkit_editGetSelectedText ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gchar *buf = gtk_editable_get_chars( ed, ed->selection_start_pos, ed->selection_end_pos);

  return (*env)->NewStringUTF( env, buf);
}

void
Java_java_awt_Toolkit_editSetEditable ( JNIEnv* env, jclass clazz, void* nd, jboolean edit )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gtk_editable_set_editable( ed, edit);
}

guint
Java_java_awt_Toolkit_editGetSelectionStart ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  return ed->selection_start_pos;
}

void
Java_java_awt_Toolkit_editSetSelectionStart ( JNIEnv* env, jclass clazz, void* nd, jint start )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gint end = ed->selection_end_pos;
  gtk_editable_select_region( ed, start, end);}

int
Java_java_awt_Toolkit_editGetSelectionEnd ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  return ed->selection_end_pos;
}

void
Java_java_awt_Toolkit_editSetSelectionEnd ( JNIEnv* env, jclass clazz, void* nd, jint end )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gint start = ed->selection_start_pos;
  gtk_editable_select_region( ed, start, end);
}

void
Java_java_awt_Toolkit_editSelect ( JNIEnv* env, jclass clazz, void* nd, int start, int end )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gtk_editable_select_region( ed, start, end);
}

void
Java_java_awt_Toolkit_editSelectAll ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gtk_editable_select_region( ed, 0, -1);
}

void
Java_java_awt_Toolkit_editSetCaretPosition ( JNIEnv* env, jclass clazz, void* nd, jint pos )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  gtk_editable_set_position( ed, pos);
}

jint
Java_java_awt_Toolkit_editGetCaretPosition ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkEditable* ed = GTK_EDITABLE( ((Widget*)nd)->widget);
  return gtk_editable_get_position( ed);
}
