/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>


void*
Java_java_awt_Toolkit_lblCreateLabel ( JNIEnv* env, jclass clazz, jstring text )
{
  Widget *widget = calloc( 1, sizeof( Widget));
  char *buf = java2CString( env, X, text);

  widget->widget = gtk_label_new( buf);
  return (void*)widget;
}

void
Java_java_awt_Toolkit_lblSet ( JNIEnv* env, jclass clazz, void* nd, jstring text )
{
  GtkLabel *lbl = GTK_LABEL( ((Widget*)nd)->widget);
  char *buf = java2CString( env, X, text);
  gtk_label_set( lbl, buf);
}

void
Java_java_awt_Toolkit_lblSetJustify ( JNIEnv* env, jclass clazz, void* nd, GtkJustification just )
{
  GtkLabel *lbl = GTK_LABEL( ((Widget*)nd)->widget);
  gtk_label_set_justify( lbl, just);
}

jstring
Java_java_awt_Toolkit_lblGet ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkLabel *lbl = GTK_LABEL( ((Widget*)nd)->widget);
  char** buf;

  gtk_label_get( lbl, buf);
  return (*env)->NewStringUTF( env, *buf);
}
