/**
 * tlk.c - 
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#define MAIN

#include "config.h"
#include "toolkit.h"

jclass EventDispatchThread;
jmethodID idleCallback;

/********************************************************************************
 * auxiliary functions
 */


/********************************************************************************
 *
 */

jstring
Java_java_awt_Toolkit_tlkVersion ( JNIEnv* env, jclass clazz )
{
  return (*env)->NewStringUTF( env, "X-1.0");
}

/*
 * we do this native because of two reasons: (1) this should appear as fast as
 * possible (without being deferred by potential lengthy Java inits), (2) in
 * native window systems we can't draw to the "root-window" from within Java
 */
void
displayBanner ( JNIEnv* env, jclass clazz, jstring banner )
{
  /* no X banner yet */
}

gint idle_callback( gpointer data) {

    (*X->env)->CallStaticObjectMethod( X->env, EventDispatchThread, idleCallback);
    return 1;
}

void
Java_java_awt_Toolkit_tlkInit ( JNIEnv* env, jclass clazz, jstring name, jstring banner )
{
  char *dspName;

  X->nBuf = 128;
  X->buf = malloc( X->nBuf);

  X->env = env;

  /*
  XSetErrorHandler( xErrorHandler);

  if ( name ) {
	dspName = java2CString( env, X, name);
  }
  else {
	if ( !(dspName = getenv( "DISPLAY")) )
	  dspName = ":0.0";
  }

  if ( !(X->dsp = XOpenDisplay( dspName)) ) {
	fprintf( stderr, "XOpenDisplay failed: %s\n", dspName);
	return;
  }
  
#ifdef DEBUG
  XSynchronize( X->dsp, True);
#endif

  X->root = DefaultRootWindow( X->dsp);

  */

  initColorMapping( env, X);
  /*
  WM_PROTOCOLS     = gdk_atom_intern( "WM_PROTOCOLS", 0);
  WM_DELETE_WINDOW = gdk_atom_intern( "WM_DELETE_WINDOW", 0);

  WM_TAKE_FOCUS    = gdk_atom_intern( "WM_TAKE_FOCUS", 0);
  WAKEUP           = gdk_atom_intern( "WAKEUP", 0);
  RETRY_FOCUS      = gdk_atom_intern( "RETRY_FOCUS", 0);
  */
  if ( banner )
	displayBanner( env, clazz, banner);

  EventDispatchThread  = (*env)->FindClass( env, "java/awt/EventDispatchThread");
  idleCallback   = (*env)->GetStaticMethodID( env, EventDispatchThread, "idleCallback", "()V");

  gtk_init( NULL, NULL);

}

void
Java_java_awt_Toolkit_tlkStartDispatch ( JNIEnv* env, jclass clazz )
{
  gtk_idle_add( idle_callback, NULL); 
  gtk_main();
}

void
Java_java_awt_Toolkit_tlkTerminate ( JNIEnv* env, jclass clazz )
{
  if ( X->cbdOwner ) {
	gdk_window_destroy( X->cbdOwner);
	X->cbdOwner = NULL;
  }
}


jint
Java_java_awt_Toolkit_tlkGetResolution ( JNIEnv* env, jclass clazz )
{
  /*
   * We are interested in pixels per inch
   */

  return ((gdk_screen_width() * 254) + 5) / (gdk_screen_width_mm() * 10);
}


jint
Java_java_awt_Toolkit_tlkGetScreenHeight ( JNIEnv* env, jclass clazz )
{
  return gdk_screen_height();
}


jint
Java_java_awt_Toolkit_tlkGetScreenWidth ( JNIEnv* env, jclass clazz )
{
  return gdk_screen_width();
}


jboolean
Java_java_awt_Toolkit_tlkIsMultiThreaded ( JNIEnv* env, jclass clazz )
{
#ifdef USE_NATIVE_THREADS
  return JNI_TRUE;
#else
  return JNI_FALSE;
#endif
}


void
Java_java_awt_Toolkit_tlkSync ( JNIEnv* env, jclass clazz )
{
  //  XSync( X->dsp, False);
}


void
Java_java_awt_Toolkit_tlkBeep ( JNIEnv* env, jclass clazz )
{
  gdk_beep();
}
