/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>


void*
Java_java_awt_Toolkit_txtCreateText ( JNIEnv* env, jclass clazz, jstring text )
{
  Widget *widget = calloc( 1, sizeof( Widget));
  char* buf = java2CString( env, X, text);

  widget->widget = gtk_text_new( NULL, NULL);

  gtk_widget_set_events( widget->widget, GDK_ALL_EVENTS_MASK);
  connect_wdg_signals( widget );

  return (void*)widget;
}

void
Java_java_awt_Toolkit_txtSetEditable ( JNIEnv* env, jclass clazz, void* nd, jboolean editable )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_set_editable( txt, editable);
}


void
Java_java_awt_Toolkit_txtSetPoint ( JNIEnv* env, jclass clazz, void* nd, jint index )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_set_point( txt, index);
}

guint
Java_java_awt_Toolkit_txtGetPoint ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  return gtk_text_get_point( txt);
}

guint
Java_java_awt_Toolkit_txtGetLength ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  return gtk_text_get_length( txt);
}

void
Java_java_awt_Toolkit_txtFreeze ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_freeze ( txt);
}

void
Java_java_awt_Toolkit_txtThaw ( JNIEnv* env, jclass clazz, void* nd )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_thaw( txt);
}

void
Java_java_awt_Toolkit_txtAppend ( JNIEnv* env, jclass clazz, void* nd, jstring text)
{
}

void
Java_java_awt_Toolkit_txtInsert ( JNIEnv* env, jclass clazz, void* nd, GdkFont* gf,
				  jint cf, jint cb, jstring text, jint len )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  GdkColor gcf;
  GdkColor gcb;
  char *buf;

  gcf.pixel = cf;
  gcb.pixel = cb;

  if ( text ) {
    buf = java2CString( env, X, text);
    gtk_text_insert( txt, gf, &gcf, &gcb, buf, len);
  }
}

void
Java_java_awt_Toolkit_txtBackwardDelete ( JNIEnv* env, jclass clazz, void* nd, jint len )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_backward_delete( txt, len);
}

void
Java_java_awt_Toolkit_txtForwardDelete ( JNIEnv* env, jclass clazz, void* nd, jint len )
{
  GtkText *txt = GTK_TEXT( ((Widget*)nd)->widget);
  gtk_text_forward_delete( txt, len);
}
