/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include <stdio.h>
#include <gtk/gtk.h>
#include <toolkit.h>

void set_widget_attribs( Widget* w)
{
  /*
  GdkColor c;
  GtkStyle* s = gtk_widget_get_style( w->widget);
  s->bg[GTK_STATE_NORMAL].pixel = w->bg;
  gtk_widget_set_style( w->widget, s);
  //c.pixel = w->bg;
  //gdk_window_set_background( w->widget->window, &c);
  //gdk_window_set_cursor( w->widget->window, w->cursor);
  */
}

void
realize_callback( GtkWidget* w, gpointer data)
{
  set_widget_attribs( (Widget*) data);
}

void
connect_wdg_signals( Widget* widget) {

  GtkWidget* wnd = widget->widget;

  gtk_signal_connect( GTK_OBJECT( wnd), "button_press_event", GTK_SIGNAL_FUNC( button_press_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "button_release_event", GTK_SIGNAL_FUNC( button_release_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "motion_notify_event", GTK_SIGNAL_FUNC( motion_notify_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "key_press_event", GTK_SIGNAL_FUNC( key_press_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "key_release_event", GTK_SIGNAL_FUNC( key_release_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "enter_notify_event", GTK_SIGNAL_FUNC( enter_notify_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "leave_notify_event", GTK_SIGNAL_FUNC( leave_notify_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "configure_event", GTK_SIGNAL_FUNC( configure_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "focus_in_event", GTK_SIGNAL_FUNC( focus_in_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "focus_out_event", GTK_SIGNAL_FUNC( focus_out_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "map_event", GTK_SIGNAL_FUNC( map_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "unmap_event", GTK_SIGNAL_FUNC( unmap_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "visibility_notify_event", GTK_SIGNAL_FUNC( visibility_notify_callback), NULL);
  gtk_signal_connect( GTK_OBJECT( wnd), "realize", GTK_SIGNAL_FUNC( realize_callback), widget);
}

void
Java_java_awt_Toolkit_wdgSetBounds ( JNIEnv* env, jclass clazz, void* wdg, jint x, jint y, jint width, jint height )
{
  GtkWidget* w = ((Widget*)wdg)->widget;
  gtk_widget_set_uposition( w, x, y);
  gtk_widget_set_usize( w, width, height);
}

void
Java_java_awt_Toolkit_wdgSetVisible ( JNIEnv* env, jclass clazz, void* wdg, jboolean vis )
{
  GtkWidget* w = ((Widget*)wdg)->widget;

  if ( vis ) {
    gtk_widget_show( w);
  }
  else {
    gtk_widget_hide( w);
  }
}

void
Java_java_awt_Toolkit_wdgSetBackground ( JNIEnv* env, jclass clazz, void* wdg, jint clr )
{
  Widget* w = (Widget*)wdg;
  GdkWindow* wnd = w->widget->window;
  GdkColor   gc;

  w->bg = clr;
  if ( wnd != NULL ) {
    gc.pixel = clr;
    gdk_window_set_background( wnd, &gc);
  }
}

void
Java_java_awt_Toolkit_wdgSetForeground ( JNIEnv* env, jclass clazz, void* wdg, jint clr )
{
  Widget* w = (Widget*)wdg;
  GdkWindow* wnd = w->widget->window;
  GdkColor   gc;

  w->fg = clr;
  if ( wnd != NULL ) {
    gc.pixel = clr;
    // gdk_window_set_foreground( wnd, &gc);
  }
}

void
Java_java_awt_Toolkit_wdgSetFont ( JNIEnv* env, jclass clazz, void* wdg, void* fnt )
{
  Widget* w = (Widget*)wdg;
  GtkStyle* s = gtk_widget_get_style( w->widget);
  w->fnt = s->font = (GdkFont*)fnt;
  gtk_widget_set_style( w->widget, s);
}

void
Java_java_awt_Toolkit_wdgDraw ( JNIEnv* env, jclass clazz, void* wdg )
{
  GtkWidget* w = ((Widget*)wdg)->widget;
  gtk_widget_draw_default( w);
}
