package java.awt;


/**
 *
 * Copyright (c) 1998
 *   Transvirtual Technologies Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 * @author P.C.Mehlitz
 */
public class EventQueue
{
	AWTEvent queue;

public EventQueue () {
}

public AWTEvent getNextEvent () {
	AWTEvent e;

	synchronized ( this ) {
	  if ( queue == null )
	    return null;
	
	  e = queue;
	  queue = e.next;
	  e.next = null;
	  return e;
	}

}

public AWTEvent peekEvent () {
	return queue;
}

public synchronized AWTEvent peekEvent ( int id ) {
	AWTEvent e = null;

	if ( queue != null ) {
		for ( e=queue; (e != null) && (e.id != id); e = e.next );
	}
	
	return e;
}

public synchronized void postEvent ( AWTEvent e ) {
	if ( queue == null )
		queue = e;
	else {
		AWTEvent q;
		for ( q=queue; q.next != null; q = q.next );
		q.next = e;
	}
		
}
}






