/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


package java.awt;

import java.awt.event.TextListener;
import java.awt.event.TextEvent;

public class TextComponent
extends NativeComponent
{
  String text;
  boolean isEditable = true;

  TextComponent () {
    cursor = Cursor.getPredefinedCursor( Cursor.TEXT_CURSOR);
  }

  public void addNotify() {
    Toolkit.editSetEditable( nativeData, isEditable);
    super.addNotify();
  }

  public void setText( String text) {
    this.text = text;
    if ( nativeData != null )
      Toolkit.editSetText( nativeData, text);
  }

  public String getText() {
    if ( nativeData != null )
      text = Toolkit.editGetText( nativeData);

    return text;
  }

  public String getSelectedText() {
    if ( nativeData != null )
      return Toolkit.editGetSelectedText( nativeData);
    return null;
  }

  public boolean isEditable() {
    return isEditable;
  }

  public void setEditable( boolean edit ) {
    isEditable = edit;
    if ( nativeData != null )
      Toolkit.editSetEditable( nativeData, edit);
  }

  public int getSelectionStart() {
    if ( nativeData != null )
      return Toolkit.editGetSelectionStart( nativeData);
    return 0;
  }

  public void setSelectionStart( int start) {
    if ( nativeData != null )
      Toolkit.editSetSelectionStart( nativeData, start);
  }

  public int getSelectionEnd() {
    if ( nativeData != null )
      return Toolkit.editGetSelectionEnd( nativeData);
    return 0;
  }

  public void setSelectionEnd( int end) {
    if ( nativeData != null )
      Toolkit.editSetSelectionEnd( nativeData, end);
  }

  public void select( int start, int end) {
    if ( nativeData != null )
      Toolkit.editSelect( nativeData, start, end);
  }

  public void selectAll() {
    if ( nativeData != null )
      Toolkit.editSelectAll( nativeData);
  }

  public void setCaretPosition( int pos) {
    if ( nativeData != null )
      Toolkit.editSetCaretPosition( nativeData, pos);
  }

  public int getCaretPosition() {
    if ( nativeData != null )
      return Toolkit.editGetCaretPosition( nativeData);
    return 0;
  }

  public void addTextListener( TextListener l) {
  }

  public void removeTextListener( TextListener l) {
  }
}

