/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


package java.awt;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class TextField
extends TextComponent
{
  char echoChar;
  int cols;

  public TextField() {
    this( "", 0);
  }

  public TextField( String text) {
    this( text, text.length() );
  }

  public TextField( int cols) {
    this( "", cols);
  }

  public TextField( String text, int cols) {
    this.cols = cols;

    cursor = Cursor.getPredefinedCursor( Cursor.TEXT_CURSOR);
    setBackground( Defaults.TextFieldBgClr);
    setForeground( Defaults.TextFieldTxtClr);
    setFont( Defaults.TextFieldFont);
    setText( text);
  }

  public void addNotify() {
    if ( nativeData == null ) {
      nativeData = Toolkit.entryCreateEntry( text);
      super.addNotify();
    }
  }

  public char getEchoChar() {
    return echoChar;
  }

  public void setEchoChar( char c) {
    echoChar = c;
  }

  public boolean echoCharIsSet() {
    return echoChar != 0;
  }

  public int getColumns() {
    return cols;
  }

  public void setColumns( int cols) {
    this.cols = cols;
  }

  public Dimension getPreferredSize( int cols) {
    FontMetrics fm = getFontMetrics( getFont() );
    return new Dimension( cols * fm.charWidth( 'x'), 3*fm.getHeight()/2);
  }

  public Dimension getPreferredSize() {
    return getPreferredSize( Math.max( 10, text.length() )); ;
  }

  public Dimension getMinimumSize( int cols) {
    return new Dimension( 50, 50);
  }

  public Dimension getMinimumSize() {
    return new Dimension( 50, 50);
  }

  public void addActionListener( ActionListener l) {
  }

  public void removeActionListener( ActionListener l) {
  }

  protected String paramString() {
    return "";
  }
} 
